/*
 *  inodes.h --
 *      Inode interface file.
 *
 *  Author:
 *      See-Mong Tan
 */

  /* init */
extern bool_t inode_init(void);
  /* add a path name to the directory tree */
extern u_long addpathtodirtree(char *);
  /* remove an inode from the directory tree */
extern void inremnode(u_long);
  /* path name to inode */
extern long pntoin(char *);
  /* inode to path name in dos format */
extern char *intopn(unsigned long, char *);
  /* inode to name */
extern char *intoname(unsigned long);
  /* inode get parent */
extern u_long parentinode (u_long);
  /* inode get file attributes */
struct nfsfattr *inattrget (u_long, struct nfsfattr *);
  /* inode set file attributes */
struct nfsfattr *inattrset (u_long, struct nfsfattr *);
  /* inode get entry */
long ingetentry (u_long, u_long, char *);
  /* inode get filesys ID */
extern int ingetfsid (u_long);
  /* path name to file handle */
extern fhandle_t pntofh(char *);
  /* check file handle */
extern bool_t checkfh (fhandle_t *);

  /* Valid-character array */
extern u_char inchvalid[];
